/****************************************************************************
; *
; *     File        : entrypoint.cpp
; *
; *     Description : OpenGL entry point
; *
; *     Copyright  Realtech VR 2001
; *
; *     Permission to use, copy, modify, distribute and sell this software
; *     and its documentation for any purpose is hereby granted without fee,
; *     provided that the above copyright notice appear in all copies and
; *     that both that copyright notice and this permission notice appear
; *     in supporting documentation.  Realtech makes no representations
; *     about the suitability of this software for any purpose.
; *     It is provided "as is" without express or implied warranty.
; *
; ***************************************************************************/
#include <assert.h> // assert
#include <gl/gl.h>
#include "../gl_init.h"
#include "wglext.h"
#include "d3d8.h"
#include "resource.h"

#define ASSERT assert
#include <stdio.h>  // MESG
void MESG(const char *pszFormat, ...)
{
	char s[128];
	va_list va;
	va_start(va, pszFormat);
	vsprintf(s, pszFormat, va);
	va_end(va);
	OutputDebugString(s);
	

	FILE *fp;
	fp = fopen("d3d8.log","a+t");
	if (fp)
	{		
		fprintf(fp,"%s",s);
		fclose(fp);
	}
}


// Win32 GL Driver
struct gl_driver_information {
	int			nmode;
};


void GL_GetCreationParameters(struct gl_driver_information *pDevice, struct _D3DDEVICE_CREATION_PARAMETERS *p)
{
	p->AdapterOrdinal = D3DADAPTER_DEFAULT ;
	p->BehaviorFlags = D3DCREATE_PUREDEVICE | D3DCREATE_MULTITHREADED | D3DCREATE_HARDWARE_VERTEXPROCESSING ;
	p->DeviceType = D3DDEVTYPE_HAL;
	p->hFocusWindow = pDevice->hwnd;
}

// This is the default Direct3D 8 mode
void GL_DefaultSettings(int width, int height)
{
	glEnable(GL_CULL_FACE);
	glCullFace(GL_FRONT);
    
	glMatrixMode( GL_PROJECTION);
    glLoadIdentity();
	glMatrixMode( GL_MODELVIEW );
    glLoadIdentity();

    glViewport(0, 0, width, height);
    glOrtho(0, width, height, 0, 1, -1 );	
    
    glPixelStorei( GL_UNPACK_ALIGNMENT, 1);
    glAlphaFunc( GL_GEQUAL, 0.5f);

}

// TODO: Use wglAllocateMemoryNV if available
void *glAllocateMemory(int size)
{
	return new BYTE[size];
}

// TODO: Use wglFreeMemoryNV if available
void glFreeMemory(void *ptr)
{
	delete [] ptr;
}
// Create pseudo device
int GL_CreatePseudoDevice(struct gl_driver_information **pDevice)
{
	gl_driver_information *p = new gl_driver_information;
	*pDevice = 0;

	if (!p)
		return -4;
	memset(p, 0, sizeof(gl_driver_information));
	p->hwnd = (HWND)0;

	*pDevice = p;
	return 0;
}


// Get Display mode 
void GL_GetAdapterDisplayMode(struct gl_driver_information *pDevice, UINT *width, UINT *height, UINT *bpp, UINT *refreshRate)
{

	return;
}
// Get adapter driver name

void GL_GetAdapterName(struct gl_driver_information *pDevice, int index, char *s, int numBytes)
{
	return;
}
// Get number of display modes available

int GL_GetAdapterModeCount(struct gl_driver_information *pDevice)
{
	return pDevice->nmode;
}
// Get Adapter Count
int GL_GetAdapterCount(struct gl_driver_information *pDevice)
{
	return 1;
}

// Get adapter mode
void GL_EnumAdapterModes(struct gl_driver_information *pDevice, int index, UINT *width, UINT *height, UINT *bpp, UINT *refreshRate)
{
}

// Setup pixel format
static int SetupPixelFormat(HDC hDC, int bpp, int depth, int dlb, int acc)
{
	return 0;
}

// Page flipping
void GL_PresentDevice(struct gl_driver_information *pDevice)
{
	return;
}

// Device creation
int GL_CreateDevice(struct gl_driver_information **pDevice, void *hwnd, int deviceId, int width, int height)
{
	GL_DefaultSettings(width, height);	
	return 0;
}

void GL_ReleaseDevice(struct gl_driver_information *pDevice)
{
	return;
}
const char *GL_GetErrorString(GLenum err)
{
	switch(err)
	{
		case GL_NO_ERROR: return "NO ERROR"; 
		case GL_INVALID_ENUM: return "INVALID ENUM"; 
		case GL_INVALID_OPERATION: return "INVALID OPERATION"; 		
		case GL_STACK_UNDERFLOW: return "STACK UNDERFLOW"; 
		case GL_STACK_OVERFLOW: return "STACK OVERFLOW"; 
		case GL_OUT_OF_MEMORY: return "OUT OF MEMORY"; 
	}
	return "UNDEFINED";
}

void DisplaySplashScreen(int sdk)
{
}
