/*
** realtech VR, Inc.
** http://www.realtech-vr.com
** Copyright (c) 2000-2002.  All Rights Reserved
**
** Source code from realtech VR is supplied under the terms of a license
** agreement and may not be copied or disclosed except in accordance with the
** terms of that agreement.  The various license agreements may be found at
** the realtech VR web site.  This file is Open Source
**
** FREE SOURCE CODE
** http://www.realtech-vr.com
**
** MCD/ICD Driver - Only supports GL (not GLU)
**
**
*/
// #include "stdafx.h" // Uncomment this for pre-compiled support.

#include <assert.h>
#include <windows.h>
#define __GL_MCD_C

#include "mcd.h"

// GetProcAddress must success (so we adding an assert)
#define MCD_GET_PROC(h, func) fn##func = (void*) GetProcAddress(h, #func); assert(fn##func);

// No assert here (ICD may not export all the function)
#define MCD_GET_PROC_WGL(h, func) mcd##func = (void*) GetProcAddress(h, "wgl"#func);

static void mcdSolveAddr(HINSTANCE hInst)
{
	MCD_GET_PROC( hInst,  glAlphaFunc     );
	MCD_GET_PROC( hInst,  glBegin         );
	MCD_GET_PROC( hInst,  glBindTexture   );
	MCD_GET_PROC( hInst,  glBlendFunc     );
	MCD_GET_PROC( hInst,  glClear         );
	MCD_GET_PROC( hInst,  glClearColor    );
	MCD_GET_PROC( hInst,  glClearDepth    );
	MCD_GET_PROC( hInst,  glColor3f       );
	MCD_GET_PROC( hInst,  glColor3fv      );
	MCD_GET_PROC( hInst,  glColor4f       );
	MCD_GET_PROC( hInst,  glColor4fv      );
	MCD_GET_PROC( hInst,  glCullFace      );
	MCD_GET_PROC( hInst,  glDepthFunc     );
	MCD_GET_PROC( hInst,  glDisable       );
	MCD_GET_PROC( hInst,  glEnable        );
	MCD_GET_PROC( hInst,  glEnd           );
	MCD_GET_PROC( hInst,  glFinish        );
	MCD_GET_PROC( hInst,  glFrontFace     );
	MCD_GET_PROC( hInst,  glFrustum       );
	MCD_GET_PROC( hInst,  glGetError      );
	MCD_GET_PROC( hInst,  glGetFloatv     );
	MCD_GET_PROC( hInst,  glGetIntegerv   );
	MCD_GET_PROC( hInst,  glGetString     );
	MCD_GET_PROC( hInst,  glHint          );
	MCD_GET_PROC( hInst,  glIsEnabled     );
	MCD_GET_PROC( hInst,  glLoadIdentity  );
	MCD_GET_PROC( hInst,  glLoadMatrixf   );
	MCD_GET_PROC( hInst,  glMatrixMode    );
	MCD_GET_PROC( hInst,  glMultMatrixf   );
	MCD_GET_PROC( hInst,  glOrtho         );
	MCD_GET_PROC( hInst,  glPixelStorei   );
	MCD_GET_PROC( hInst,  glPolygonOffset );
	MCD_GET_PROC( hInst,  glPopMatrix     );
	MCD_GET_PROC( hInst,  glPushMatrix    );
	MCD_GET_PROC( hInst,  glRotatef       );
	MCD_GET_PROC( hInst,  glScalef        );
	MCD_GET_PROC( hInst,  glShadeModel    );
	MCD_GET_PROC( hInst,  glTexCoord2f    );
	MCD_GET_PROC( hInst,  glTexCoord2fv   );
	MCD_GET_PROC( hInst,  glTexCoord3f    );
	MCD_GET_PROC( hInst,  glTexCoord3fv   );
	MCD_GET_PROC( hInst,  glTexEnvf       );
	MCD_GET_PROC( hInst,  glTexImage2D    );
	MCD_GET_PROC( hInst,  glTexParameterf );
	MCD_GET_PROC( hInst,  glTranslatef    );
	MCD_GET_PROC( hInst,  glVertex2f      );
	MCD_GET_PROC( hInst,  glVertex3f      );
	MCD_GET_PROC( hInst,  glVertex3fv     );
	MCD_GET_PROC( hInst,  glVertex4f      );
	MCD_GET_PROC( hInst,  glViewport      );
	MCD_GET_PROC( hInst,  glAccum                  );
	MCD_GET_PROC( hInst,  glAlphaFunc              );
	MCD_GET_PROC( hInst,  glAreTexturesResident    );
	MCD_GET_PROC( hInst,  glArrayElement           );
	MCD_GET_PROC( hInst,  glBegin                  );
	MCD_GET_PROC( hInst,  glBindTexture            );
	MCD_GET_PROC( hInst,  glBitmap                 );
	MCD_GET_PROC( hInst,  glBlendFunc              );
	MCD_GET_PROC( hInst,  glCallList               );
	MCD_GET_PROC( hInst,  glCallLists              );
	MCD_GET_PROC( hInst,  glClear                  );
	MCD_GET_PROC( hInst,  glClearAccum             );
	MCD_GET_PROC( hInst,  glClearColor             );
	MCD_GET_PROC( hInst,  glClearDepth             );
	MCD_GET_PROC( hInst,  glClearIndex             );
	MCD_GET_PROC( hInst,  glClearStencil           );
	MCD_GET_PROC( hInst,  glClipPlane              );
	MCD_GET_PROC( hInst,  glColor3b                );
	MCD_GET_PROC( hInst,  glColor3bv               );
	MCD_GET_PROC( hInst,  glColor3d                );
	MCD_GET_PROC( hInst,  glColor3dv               );
	MCD_GET_PROC( hInst,  glColor3f                );
	MCD_GET_PROC( hInst,  glColor3fv               );
	MCD_GET_PROC( hInst,  glColor3i                );
	MCD_GET_PROC( hInst,  glColor3iv               );
	MCD_GET_PROC( hInst,  glColor3s                );
	MCD_GET_PROC( hInst,  glColor3sv               );
	MCD_GET_PROC( hInst,  glColor3ub               );
	MCD_GET_PROC( hInst,  glColor3ubv              );
	MCD_GET_PROC( hInst,  glColor3ui               );
	MCD_GET_PROC( hInst,  glColor3uiv              );
	MCD_GET_PROC( hInst,  glColor3us               );
	MCD_GET_PROC( hInst,  glColor3usv              );
	MCD_GET_PROC( hInst,  glColor4b                );
	MCD_GET_PROC( hInst,  glColor4bv               );
	MCD_GET_PROC( hInst,  glColor4d                );
	MCD_GET_PROC( hInst,  glColor4dv               );
	MCD_GET_PROC( hInst,  glColor4f                );
	MCD_GET_PROC( hInst,  glColor4fv               );
	MCD_GET_PROC( hInst,  glColor4i                );
	MCD_GET_PROC( hInst,  glColor4iv               );
	MCD_GET_PROC( hInst,  glColor4s                );
	MCD_GET_PROC( hInst,  glColor4sv               );
	MCD_GET_PROC( hInst,  glColor4ub               );
	MCD_GET_PROC( hInst,  glColor4ubv              );
	MCD_GET_PROC( hInst,  glColor4ui               );
	MCD_GET_PROC( hInst,  glColor4uiv              );
	MCD_GET_PROC( hInst,  glColor4us               );
	MCD_GET_PROC( hInst,  glColor4usv              );
	MCD_GET_PROC( hInst,  glColorMask              );
	MCD_GET_PROC( hInst,  glColorMaterial          );
	MCD_GET_PROC( hInst,  glColorPointer           );
	MCD_GET_PROC( hInst,  glCopyPixels             );
	MCD_GET_PROC( hInst,  glCopyTexImage1D         );
	MCD_GET_PROC( hInst,  glCopyTexImage2D         );
	MCD_GET_PROC( hInst,  glCopyTexSubImage1D      );
	MCD_GET_PROC( hInst,  glCopyTexSubImage2D      );
	MCD_GET_PROC( hInst,  glCullFace               );
	MCD_GET_PROC( hInst,  glDeleteLists            );
	MCD_GET_PROC( hInst,  glDeleteTextures         );
	MCD_GET_PROC( hInst,  glDepthFunc              );
	MCD_GET_PROC( hInst,  glDepthMask              );
	MCD_GET_PROC( hInst,  glDepthRange             );
	MCD_GET_PROC( hInst,  glDisable                );
	MCD_GET_PROC( hInst,  glDisableClientState     );
	MCD_GET_PROC( hInst,  glDrawArrays             );
	MCD_GET_PROC( hInst,  glDrawBuffer             );
	MCD_GET_PROC( hInst,  glDrawElements           );
	MCD_GET_PROC( hInst,  glDrawPixels             );
	MCD_GET_PROC( hInst,  glEdgeFlag               );
	MCD_GET_PROC( hInst,  glEdgeFlagPointer        );
	MCD_GET_PROC( hInst,  glEdgeFlagv              );
	MCD_GET_PROC( hInst,  glEnable                 );
	MCD_GET_PROC( hInst,  glEnableClientState      );
	MCD_GET_PROC( hInst,  glEnd                    );
	MCD_GET_PROC( hInst,  glEndList                );
	MCD_GET_PROC( hInst,  glEvalCoord1d            );
	MCD_GET_PROC( hInst,  glEvalCoord1dv           );
	MCD_GET_PROC( hInst,  glEvalCoord1f            );
	MCD_GET_PROC( hInst,  glEvalCoord1fv           );
	MCD_GET_PROC( hInst,  glEvalCoord2d            );
	MCD_GET_PROC( hInst,  glEvalCoord2dv           );
	MCD_GET_PROC( hInst,  glEvalCoord2f            );
	MCD_GET_PROC( hInst,  glEvalCoord2fv           );
	MCD_GET_PROC( hInst,  glEvalMesh1              );
	MCD_GET_PROC( hInst,  glEvalMesh2              );
	MCD_GET_PROC( hInst,  glEvalPoint1             );
	MCD_GET_PROC( hInst,  glEvalPoint2             );
	MCD_GET_PROC( hInst,  glFeedbackBuffer         );
	MCD_GET_PROC( hInst,  glFinish                 );
	MCD_GET_PROC( hInst,  glFlush                  );
	MCD_GET_PROC( hInst,  glFogf                   );
	MCD_GET_PROC( hInst,  glFogfv                  );
	MCD_GET_PROC( hInst,  glFogi                   );
	MCD_GET_PROC( hInst,  glFogiv                  );
	MCD_GET_PROC( hInst,  glFrontFace              );
	MCD_GET_PROC( hInst,  glFrustum                );
	MCD_GET_PROC( hInst,  glGenLists               );
	MCD_GET_PROC( hInst,  glGenTextures            );
	MCD_GET_PROC( hInst,  glGetBooleanv            );
	MCD_GET_PROC( hInst,  glGetClipPlane           );
	MCD_GET_PROC( hInst,  glGetDoublev             );
	MCD_GET_PROC( hInst,  glGetError               );
	MCD_GET_PROC( hInst,  glGetFloatv              );
	MCD_GET_PROC( hInst,  glGetIntegerv            );
	MCD_GET_PROC( hInst,  glGetLightfv             );
	MCD_GET_PROC( hInst,  glGetLightiv             );
	MCD_GET_PROC( hInst,  glGetMapdv               );
	MCD_GET_PROC( hInst,  glGetMapfv               );
	MCD_GET_PROC( hInst,  glGetMapiv               );
	MCD_GET_PROC( hInst,  glGetMaterialfv          );
	MCD_GET_PROC( hInst,  glGetMaterialiv          );
	MCD_GET_PROC( hInst,  glGetPixelMapfv          );
	MCD_GET_PROC( hInst,  glGetPixelMapuiv         );
	MCD_GET_PROC( hInst,  glGetPixelMapusv         );
	MCD_GET_PROC( hInst,  glGetPointerv            );
	MCD_GET_PROC( hInst,  glGetPolygonStipple      );
	MCD_GET_PROC( hInst,  glGetString              );
	MCD_GET_PROC( hInst,  glGetTexEnvfv            );
	MCD_GET_PROC( hInst,  glGetTexEnviv            );
	MCD_GET_PROC( hInst,  glGetTexGendv            );
	MCD_GET_PROC( hInst,  glGetTexGenfv            );
	MCD_GET_PROC( hInst,  glGetTexGeniv            );
	MCD_GET_PROC( hInst,  glGetTexImage            );
	MCD_GET_PROC( hInst,  glGetTexLevelParameterfv );
	MCD_GET_PROC( hInst,  glGetTexLevelParameteriv );
	MCD_GET_PROC( hInst,  glGetTexParameterfv      );
	MCD_GET_PROC( hInst,  glGetTexParameteriv      );
	MCD_GET_PROC( hInst,  glHint                   );
	MCD_GET_PROC( hInst,  glIndexMask              );
	MCD_GET_PROC( hInst,  glIndexPointer           );
	MCD_GET_PROC( hInst,  glIndexd                 );
	MCD_GET_PROC( hInst,  glIndexdv                );
	MCD_GET_PROC( hInst,  glIndexf                 );
	MCD_GET_PROC( hInst,  glIndexfv                );
	MCD_GET_PROC( hInst,  glIndexi                 );
	MCD_GET_PROC( hInst,  glIndexiv                );
	MCD_GET_PROC( hInst,  glIndexs                 );
	MCD_GET_PROC( hInst,  glIndexsv                );
	MCD_GET_PROC( hInst,  glIndexub                );
	MCD_GET_PROC( hInst,  glIndexubv               );
	MCD_GET_PROC( hInst,  glInitNames              );
	MCD_GET_PROC( hInst,  glInterleavedArrays      );
	MCD_GET_PROC( hInst,  glIsEnabled              );
	MCD_GET_PROC( hInst,  glIsList                 );
	MCD_GET_PROC( hInst,  glIsTexture              );
	MCD_GET_PROC( hInst,  glLightModelf            );
	MCD_GET_PROC( hInst,  glLightModelfv           );
	MCD_GET_PROC( hInst,  glLightModeli            );
	MCD_GET_PROC( hInst,  glLightModeliv           );
	MCD_GET_PROC( hInst,  glLightf                 );
	MCD_GET_PROC( hInst,  glLightfv                );
	MCD_GET_PROC( hInst,  glLighti                 );
	MCD_GET_PROC( hInst,  glLightiv                );
	MCD_GET_PROC( hInst,  glLineStipple            );
	MCD_GET_PROC( hInst,  glLineWidth              );
	MCD_GET_PROC( hInst,  glListBase               );
	MCD_GET_PROC( hInst,  glLoadIdentity           );
	MCD_GET_PROC( hInst,  glLoadMatrixd            );
	MCD_GET_PROC( hInst,  glLoadMatrixf            );
	MCD_GET_PROC( hInst,  glLoadName               );
	MCD_GET_PROC( hInst,  glLogicOp                );
	MCD_GET_PROC( hInst,  glMap1d                  );
	MCD_GET_PROC( hInst,  glMap1f                  );
	MCD_GET_PROC( hInst,  glMap2d                  );
	MCD_GET_PROC( hInst,  glMap2f                  );
	MCD_GET_PROC( hInst,  glMapGrid1d              );
	MCD_GET_PROC( hInst,  glMapGrid1f              );
	MCD_GET_PROC( hInst,  glMapGrid2d              );
	MCD_GET_PROC( hInst,  glMapGrid2f              );
	MCD_GET_PROC( hInst,  glMaterialf              );
	MCD_GET_PROC( hInst,  glMaterialfv             );
	MCD_GET_PROC( hInst,  glMateriali              );
	MCD_GET_PROC( hInst,  glMaterialiv             );
	MCD_GET_PROC( hInst,  glMatrixMode             );
	MCD_GET_PROC( hInst,  glMultMatrixd            );
	MCD_GET_PROC( hInst,  glMultMatrixf            );
	MCD_GET_PROC( hInst,  glNewList                );
	MCD_GET_PROC( hInst,  glNormal3b               );
	MCD_GET_PROC( hInst,  glNormal3bv              );
	MCD_GET_PROC( hInst,  glNormal3d               );
	MCD_GET_PROC( hInst,  glNormal3dv              );
	MCD_GET_PROC( hInst,  glNormal3f               );
	MCD_GET_PROC( hInst,  glNormal3fv              );
	MCD_GET_PROC( hInst,  glNormal3i               );
	MCD_GET_PROC( hInst,  glNormal3iv              );
	MCD_GET_PROC( hInst,  glNormal3s               );
	MCD_GET_PROC( hInst,  glNormal3sv              );
	MCD_GET_PROC( hInst,  glNormalPointer          );
	MCD_GET_PROC( hInst,  glOrtho                  );
	MCD_GET_PROC( hInst,  glPassThrough            );
	MCD_GET_PROC( hInst,  glPixelMapfv             );
	MCD_GET_PROC( hInst,  glPixelMapuiv            );
	MCD_GET_PROC( hInst,  glPixelMapusv            );
	MCD_GET_PROC( hInst,  glPixelStoref            );
	MCD_GET_PROC( hInst,  glPixelStorei            );
	MCD_GET_PROC( hInst,  glPixelTransferf         );
	MCD_GET_PROC( hInst,  glPixelTransferi         );
	MCD_GET_PROC( hInst,  glPixelZoom              );
	MCD_GET_PROC( hInst,  glPointSize              );
	MCD_GET_PROC( hInst,  glPolygonMode            );
	MCD_GET_PROC( hInst,  glPolygonOffset          );
	MCD_GET_PROC( hInst,  glPolygonStipple         );
	MCD_GET_PROC( hInst,  glPopAttrib              );
	MCD_GET_PROC( hInst,  glPopClientAttrib        );
	MCD_GET_PROC( hInst,  glPopMatrix              );
	MCD_GET_PROC( hInst,  glPopName                );
	MCD_GET_PROC( hInst,  glPrioritizeTextures     );
	MCD_GET_PROC( hInst,  glPushAttrib             );
	MCD_GET_PROC( hInst,  glPushClientAttrib       );
	MCD_GET_PROC( hInst,  glPushMatrix             );
	MCD_GET_PROC( hInst,  glPushName               );
	MCD_GET_PROC( hInst,  glRasterPos2d            );
	MCD_GET_PROC( hInst,  glRasterPos2dv           );
	MCD_GET_PROC( hInst,  glRasterPos2f            );
	MCD_GET_PROC( hInst,  glRasterPos2fv           );
	MCD_GET_PROC( hInst,  glRasterPos2i            );
	MCD_GET_PROC( hInst,  glRasterPos2iv           );
	MCD_GET_PROC( hInst,  glRasterPos2s            );
	MCD_GET_PROC( hInst,  glRasterPos2sv           );
	MCD_GET_PROC( hInst,  glRasterPos3d            );
	MCD_GET_PROC( hInst,  glRasterPos3dv           );
	MCD_GET_PROC( hInst,  glRasterPos3f            );
	MCD_GET_PROC( hInst,  glRasterPos3fv           );
	MCD_GET_PROC( hInst,  glRasterPos3i            );
	MCD_GET_PROC( hInst,  glRasterPos3iv           );
	MCD_GET_PROC( hInst,  glRasterPos3s            );
	MCD_GET_PROC( hInst,  glRasterPos3sv           );
	MCD_GET_PROC( hInst,  glRasterPos4d            );
	MCD_GET_PROC( hInst,  glRasterPos4dv           );
	MCD_GET_PROC( hInst,  glRasterPos4f            );
	MCD_GET_PROC( hInst,  glRasterPos4fv           );
	MCD_GET_PROC( hInst,  glRasterPos4i            );
	MCD_GET_PROC( hInst,  glRasterPos4iv           );
	MCD_GET_PROC( hInst,  glRasterPos4s            );
	MCD_GET_PROC( hInst,  glRasterPos4sv           );
	MCD_GET_PROC( hInst,  glReadBuffer             );
	MCD_GET_PROC( hInst,  glReadPixels             );
	MCD_GET_PROC( hInst,  glRectd                  );
	MCD_GET_PROC( hInst,  glRectdv                 );
	MCD_GET_PROC( hInst,  glRectf                  );
	MCD_GET_PROC( hInst,  glRectfv                 );
	MCD_GET_PROC( hInst,  glRecti                  );
	MCD_GET_PROC( hInst,  glRectiv                 );
	MCD_GET_PROC( hInst,  glRects                  );
	MCD_GET_PROC( hInst,  glRectsv                 );
	MCD_GET_PROC( hInst,  glRenderMode             );
	MCD_GET_PROC( hInst,  glRotated                );
	MCD_GET_PROC( hInst,  glRotatef                );
	MCD_GET_PROC( hInst,  glScaled                 );
	MCD_GET_PROC( hInst,  glScalef                 );
	MCD_GET_PROC( hInst,  glScissor                );
	MCD_GET_PROC( hInst,  glSelectBuffer           );
	MCD_GET_PROC( hInst,  glShadeModel             );
	MCD_GET_PROC( hInst,  glStencilFunc            );
	MCD_GET_PROC( hInst,  glStencilMask            );
	MCD_GET_PROC( hInst,  glStencilOp              );
	MCD_GET_PROC( hInst,  glTexCoord1d             );
	MCD_GET_PROC( hInst,  glTexCoord1dv            );
	MCD_GET_PROC( hInst,  glTexCoord1f             );
	MCD_GET_PROC( hInst,  glTexCoord1fv            );
	MCD_GET_PROC( hInst,  glTexCoord1i             );
	MCD_GET_PROC( hInst,  glTexCoord1iv            );
	MCD_GET_PROC( hInst,  glTexCoord1s             );
	MCD_GET_PROC( hInst,  glTexCoord1sv            );
	MCD_GET_PROC( hInst,  glTexCoord2d             );
	MCD_GET_PROC( hInst,  glTexCoord2dv            );
	MCD_GET_PROC( hInst,  glTexCoord2f             );
	MCD_GET_PROC( hInst,  glTexCoord2fv            );
	MCD_GET_PROC( hInst,  glTexCoord2i             );
	MCD_GET_PROC( hInst,  glTexCoord2iv            );
	MCD_GET_PROC( hInst,  glTexCoord2s             );
	MCD_GET_PROC( hInst,  glTexCoord2sv            );
	MCD_GET_PROC( hInst,  glTexCoord3d             );
	MCD_GET_PROC( hInst,  glTexCoord3dv            );
	MCD_GET_PROC( hInst,  glTexCoord3f             );
	MCD_GET_PROC( hInst,  glTexCoord3fv            );
	MCD_GET_PROC( hInst,  glTexCoord3i             );
	MCD_GET_PROC( hInst,  glTexCoord3iv            );
	MCD_GET_PROC( hInst,  glTexCoord3s             );
	MCD_GET_PROC( hInst,  glTexCoord3sv            );
	MCD_GET_PROC( hInst,  glTexCoord4d             );
	MCD_GET_PROC( hInst,  glTexCoord4dv            );
	MCD_GET_PROC( hInst,  glTexCoord4f             );
	MCD_GET_PROC( hInst,  glTexCoord4fv            );
	MCD_GET_PROC( hInst,  glTexCoord4i             );
	MCD_GET_PROC( hInst,  glTexCoord4iv            );
	MCD_GET_PROC( hInst,  glTexCoord4s             );
	MCD_GET_PROC( hInst,  glTexCoord4sv            );
	MCD_GET_PROC( hInst,  glTexCoordPointer        );
	MCD_GET_PROC( hInst,  glTexEnvf                );
	MCD_GET_PROC( hInst,  glTexEnvfv               );
	MCD_GET_PROC( hInst,  glTexEnvi                );
	MCD_GET_PROC( hInst,  glTexEnviv               );
	MCD_GET_PROC( hInst,  glTexGend                );
	MCD_GET_PROC( hInst,  glTexGendv               );
	MCD_GET_PROC( hInst,  glTexGenf                );
	MCD_GET_PROC( hInst,  glTexGenfv               );
	MCD_GET_PROC( hInst,  glTexGeni                );
	MCD_GET_PROC( hInst,  glTexGeniv               );
	MCD_GET_PROC( hInst,  glTexImage1D             );
	MCD_GET_PROC( hInst,  glTexImage2D             );
	MCD_GET_PROC( hInst,  glTexParameterf          );
	MCD_GET_PROC( hInst,  glTexParameterfv         );
	MCD_GET_PROC( hInst,  glTexParameteri          );
	MCD_GET_PROC( hInst,  glTexParameteriv         );
	MCD_GET_PROC( hInst,  glTexSubImage1D          );
	MCD_GET_PROC( hInst,  glTexSubImage2D          );
	MCD_GET_PROC( hInst,  glTranslated             );
	MCD_GET_PROC( hInst,  glTranslatef             );
	MCD_GET_PROC( hInst,  glVertex2d               );
	MCD_GET_PROC( hInst,  glVertex2dv              );
	MCD_GET_PROC( hInst,  glVertex2f               );
	MCD_GET_PROC( hInst,  glVertex2fv              );
	MCD_GET_PROC( hInst,  glVertex2i               );
	MCD_GET_PROC( hInst,  glVertex2iv              );
	MCD_GET_PROC( hInst,  glVertex2s               );
	MCD_GET_PROC( hInst,  glVertex2sv              );
	MCD_GET_PROC( hInst,  glVertex3d               );
	MCD_GET_PROC( hInst,  glVertex3dv              );
	MCD_GET_PROC( hInst,  glVertex3f               );
	MCD_GET_PROC( hInst,  glVertex3fv              );
	MCD_GET_PROC( hInst,  glVertex3i               );
	MCD_GET_PROC( hInst,  glVertex3iv              );
	MCD_GET_PROC( hInst,  glVertex3s               );
	MCD_GET_PROC( hInst,  glVertex3sv              );
	MCD_GET_PROC( hInst,  glVertex4d               );
	MCD_GET_PROC( hInst,  glVertex4dv              );
	MCD_GET_PROC( hInst,  glVertex4f               );
	MCD_GET_PROC( hInst,  glVertex4fv              );
	MCD_GET_PROC( hInst,  glVertex4i               );
	MCD_GET_PROC( hInst,  glVertex4iv              );
	MCD_GET_PROC( hInst,  glVertex4s               );
	MCD_GET_PROC( hInst,  glVertex4sv              );
	MCD_GET_PROC( hInst,  glVertexPointer          );
	MCD_GET_PROC( hInst,  glViewport               );

	MCD_GET_PROC_WGL( hInst, CopyContext);
	MCD_GET_PROC_WGL( hInst, CreateContext);
	MCD_GET_PROC_WGL( hInst, DeleteContext);
	MCD_GET_PROC_WGL( hInst, GetProcAddress);
	MCD_GET_PROC_WGL( hInst, MakeCurrent);
#ifdef UNICODE
	MCD_GET_PROC_WGL( hInst, UseFontBitmapsW);
#else
	MCD_GET_PROC_WGL( hInst, UseFontBitmapsA);
#endif
	MCD_GET_PROC_WGL( hInst, SwapLayerBuffers);

	MCD_GET_PROC_WGL( hInst, SwapBuffers);
	MCD_GET_PROC_WGL( hInst, ChoosePixelFormat);
	MCD_GET_PROC_WGL( hInst, DescribePixelFormat);
	MCD_GET_PROC_WGL( hInst, SetPixelFormat);
}

static HINSTANCE mcdInstall(const TCHAR *szDriverFilename)
{
	HINSTANCE hInst = LoadLibrary(szDriverFilename);
	if (hInst)
	{
		mcdSolveAddr(hInst);
	}
	return hInst;
}

static void mcdGetDefaultDriver(TCHAR *glDriver)
{
	strcpy(glDriver, "OPENGL32.DLL");
}

static HINSTANCE icdInstall()
{
	HINSTANCE hInst;
	TCHAR glDriver[_MAX_PATH];
	mcdGetDefaultDriver(glDriver);
	hInst = LoadLibrary(glDriver);
	if (hInst)
	{
		mcdSolveAddr(hInst);

		// Get functions from GDI32.LIB
		mcdSwapBuffers = (void*)SwapBuffers;
		mcdChoosePixelFormat = (void*)ChoosePixelFormat;
		mcdDescribePixelFormat = (void*)DescribePixelFormat;
		mcdSetPixelFormat = (void*)SetPixelFormat;
	}
	return hInst;
}

static HINSTANCE mcdAutoDetect()
{
	const char *driverList[] = {
		"3dfxgl.dll",	// 3Dfx
		"3dfxvgl.dll",	// 3Dfx Voodoo
		"pvrhal32.dll", // PowerVR
		"pvrgl.dll",	// PowerVR
		"opengl.dll",	// SGI OpenGL
		"opengl32.dll", // MS OpenGL
		NULL
	};
	int i = 0;
	while(driverList[i])
	{
		HINSTANCE h = mcdInstall(driverList[i]);
		if (h)
			return h;
	}
	return 0;
}

static HINSTANCE g_hMCD;

BOOL mcdInit(const TCHAR *szDriverFilename, BOOL useICD, BOOL autoDetect)
{
	if (g_hMCD)
		return FALSE; // not-rentrant

	if (useICD)
		g_hMCD = icdInstall();

	else
	if (autoDetect)
		g_hMCD = mcdAutoDetect();

	else
	if (szDriverFilename)
		g_hMCD = mcdInstall(szDriverFilename);

	if (g_hMCD)
		return TRUE;

	return FALSE;
}

BOOL mcdRelease(void)
{
	if (g_hMCD)
	{
		FreeLibrary(g_hMCD);
		g_hMCD = 0;
		return TRUE;
	}
	return FALSE;
}
